#include "Arduino.h"
#include "Snake.h"
#include "Nunchuck.h"
#include "Affichage.h"


/*** snake new direction ***/
void SnakeNewDirectionJoystick(){
  //Directions
  //0 = up
  //1 = right
  //2 = down
  //3 = left
  // 4 et 5 pour la 3e direction
  if(joyX>DEADZONEJOYX) direc = 3;
  else if(joyX<-DEADZONEJOYX) direc = 1;
  else if(joyY>DEADZONEJOYY) direc = 0;
  else if(joyY<-DEADZONEJOYY) direc = 2;
  else if(accelY<-DEADZONEY) direc = 4;
  else if(accelY>DEADZONEY) direc = 5;
}

/*
void SnakeNewDirectionAccel(){
  // Utilisation de l'accelerometre pour diriger le serpent
  //Directions
  //0 = up
  //1 = right
  //2 = down
  //3 = left
  if(accelX>DEADZONEX) direc = 3;
  else if(accelX<-DEADZONEX) direc = 1;
  else if(accelY>DEADZONEY) direc = 0;
  else if(accelY<-DEADZONEY) direc = 2;
}
*/

/*** snake new game ***/
void SnakeNewGame(){
  clearMatrix_byte();
  snakesize = 1;
  snakehead = startpoint;
  snake[0] = snakehead;
  SnakeNewApple();
  direc = 1;
  collision = 0;
  updateMatrix_byte();
}

/*** generate apple ***/
void SnakeNewApple(){
  apple = random(NB_LED);
  for (int i = 0; i < snakesize; i++){ //pour eviter que la nouvelle pomme n'apparaisse sous le snake
    if (snake[i] == apple) {
      SnakeNewApple();
    }
  }
}

/*** snake check apple ***/

void SnakeCheckApple(){
  if (snakehead == apple){
     eat = 1; //flag indiquant que la pomme est mangee
     if(snakesize<NB_LED) snakesize++; //on agrandit le snake
     SnakeNewApple(); // nouvelle pomme
  }
}


/*** snake check collision ***/
void SnakeCheckCollision(){
  for (int i = 1; i < snakesize; i++) {
    if (snake[i] == snakehead) {
      collision = 1; //flag indiquant une collision
    }
  }
}

/*** snake calculate new head position ***/
void SnakeNewHead(){
  if(direc==2){ //down
    if ((snakehead + numX) > ((numY * numX - 1))) snakehead = snakehead % numX;
    else snakehead += numY;
  }
  else if(direc==1){ //right
    if ((snakehead - (snakehead % numX)) == (((snakehead+1) - (snakehead+1) % numX))) snakehead += 1;
    else snakehead = snakehead - (numX - 1);  
  }
  else if(direc==0){ //up
    if ((snakehead - numX) < 0) snakehead += (numY - 1) * numX;
    else snakehead -= numX; 
  }
  else if(direc==3){ //left
    if (snakehead == 0) //probleme avec 0 -> on ne peut pas aller a la case -1 -> il faut aller a la case 7
      snakehead = numX-1;
    else if ((snakehead - (snakehead % numX)) == (((snakehead-1) - (snakehead-1) % numX))) snakehead -= 1;
    else snakehead += numX - 1;
 }
 else if(direc == 4){ //3e direction vers le haut : changement d'etage
   snakehead += numX * numY;
   if(snakehead > NB_LED) snakehead -= NB_LED;
 }
 else if(direc == 5){ //3e direction vers le bas
   snakehead -= numX * numY;
   if(snakehead < 0) snakehead += NB_LED;
 }
}


/*** snake move ***/
void Snake(){
  if (millis()-lastMillis >= SnakeSpeed) {
    SnakeNewHead();
    SnakeCheckApple();
    SnakeCheckCollision();
    
    if(collision == 0){ //si pas de collision
    for(int i=snakesize-1; i>0; i--) snake[i] = snake[i-1]; // on recopie le serpent en decalant d'une case
    snake[0] = snakehead;
    
    if (eat == 1) eat = 0; //remise a 0 du flag indiquant si la pomme est mangee
    updateMatrix_byte(); 
    }
      
    else {
      endGame(); //fin du jeu si collision
    }
    lastMillis = millis(); 
  }
}


/*** End game ***/
void endGame(){
  delay(1000);
  SnakeNewGame();
}

